---
title: Documentation
permalink: /docs/
toc: true
toc_sticky: true
---

**Turing** is a *universal* probabilistic programming language with an intuitive modelling interface, composable probabilistic inference and computational scalability.


Turing provides **Hamiltonian Monte Carlo** (HMC) and **particle MCMC** sampling algorithms for complex posterior distributions (e.g. those involving discrete variables and stochastic control flows). Current features include:


  * **Universal** probabilistic programming with an intuitive modelling interface;
  * **Hamiltonian Monte Carlo** (HMC) sampling for differentiable posterior distributions;
  * **Particle MCMC** sampling for complex posterior distributions involving discrete variables and stochastic control flow; and
  * **Gibbs** sampling that combines particle MCMC,  HMC and many other MCMC algorithms.


<a id='Citing-Turing-1'></a>

## Citing Turing


To cite Turing, please refer to the following paper. A sample BiBTeX entry entry is given below:


```
{% raw %}
@InProceedings{turing17,
  title = 	 {{T}uring: a language for flexible probabilistic inference},
  author = 	 {Ge, Hong and Xu, Kai and Ghahramani, Zoubin},
  booktitle = 	 {Proceedings of the 21th International Conference on Artificial Intelligence and Statistics},
  year = 	 {2018},
  series = 	 {Proceedings of Machine Learning Research},
  publisher = 	 {PMLR},
}
{% endraw %}
```


<a id='Other-Probablistic/Deep-Learning-Languages-1'></a>

## Other Probablistic/Deep Learning Languages


  * [Stan](http://mc-stan.org/)
  * [Infer.NET](https://www.microsoft.com/en-us/research/project/infernet/)
  * [PyTorch](http://pytorch.org/) / [Pyro](https://github.com/uber/pyro)
  * [TensorFlow](https://www.tensorflow.org/) / [Edward](http://edwardlib.org/)
  * [DyNet](https://github.com/clab/dynet)

