---
title: Tutorials
permalink: /tutorials/
toc: false
---

This section contains tutorials on how to implement common models in Turing. If you prefer to have an interactive Jupyter notebook, please fork or download the [TuringTutorials](https://github.com/TuringLang/TuringTutorials) repository.

A list of all the tutorials available can be found to the right. The [introduction]({{site.baseurl}}/tutorials/0-introduction/) tutorial contains an introduction to coin flipping with Turing and a brief overview of probabalistic programming.

Tutorials are under continuous development, but there are some older version available at the TuringTutorials within the [`old-notebooks`](https://github.com/TuringLang/TuringTutorialstree/master/old-notebooks/) section. Some of these were built using prior versions of Turing and may not function correctly, but they can assist in the syntax used for common models.

- [Gaussian Mixture Model](https://github.com/TuringLang/TuringTutorials/tree/master/old-notebooks/GMM.ipynb)
- [Bayesian Hidden Markov Model](https://github.com/TuringLang/TuringTutorials/tree/master/old-notebooks/BayesHmm.ipynb)
- [Factorical Hidden Markov Model](https://github.com/TuringLang/TuringTutorials/tree/master/old-notebooks/FHMM.ipynb)
- [Topic Models: LDA and MoC](https://github.com/TuringLang/TuringTutorials/tree/master/old-notebooks/TopicModels.ipynb)
